// 'currencies-menu.component.ts' file
// tslint:disable
import {Component, OnInit} from '@angular/core';
import {Router, Routes} from '@angular/router';
import {Change_route_service} from "./change-route-service";
import {Currencies} from './currencies.component';
import {Currencies_controller} from './currencies-controller.component';
import {Currencies_information} from './currencies-information.component';
import {Currencies_wrapper} from './currencies-wrapper.component';

@Component({
    selector: 'currencies-menu',
    templateUrl: './currencies-menu.component.html',
    styleUrls: ['./currencies-menu.component.css']
})
export class Currencies_menu implements OnInit {
    public static readonly Navigations: Routes = [
        {
            path: 'Currencies', // No slash, i.e., '/Currencies'
            component: Currencies_wrapper,
            data: {material_icon: 'payment'} // https://material.io/resources/icons/?style=baseline
        },
        {
            path: 'New',
            component: Currencies_controller,
            data: {material_icon: 'fiber_new'}
        },
        {
            path: ':iso_code', // Route parameter
            component: Currencies_information,
            data: {
                iso_code: Currencies.Currencies[Currencies.Dollar].iso_code,
                material_icon: Currencies.Currencies[Currencies.Dollar].material_icon
            }
        },
        {
            path: ':iso_code', // Route parameter
            component: Currencies_information,
            data: {
                iso_code: Currencies.Currencies[Currencies.Euro].iso_code,
                material_icon: Currencies.Currencies[Currencies.Euro].material_icon
            }
        },
        // Default:
        {path: '', redirectTo: 'Currencies', pathMatch: 'full'}
        // The router selects this route if the requested URL doesn't match any paths for routes defined earlier in the configuration
        // , {path: '**', component: null} /* Caution: no handler! */
    ];
    public readonly navigations = Currencies_menu.Navigations; // To let access through instance attribute...

    // Navigation logic (child-to-child communication based on injected service):
    constructor(private readonly _change_route_service: Change_route_service, private readonly _router: Router) {
    }

    ngOnInit() {
        this._change_route_service.receive_path((path: string) => {
            this._router.navigate([path]);
        });
    }
}
