// currencies-wrapper.component.ts file
// tslint:disable
import {Component} from '@angular/core';
import {Currency} from './currencies.component'; // JavaScript 'import'

@Component({ // TypeScript decorator
    selector: 'currencies-wrapper',
    template: `
        <div>
            <h2>Currency of interest: {{read()}}</h2>
            <!-- 'Currencies_wrapper' as a wrapper of 'Currencies' -->
            <!-- Data binding from parent (wrapper) to child: 'currency_of_interest_wrapper' getter is used -->
            <!-- Data binding from child to parent (wrapper): '_send_currency' received event -->
            <currencies [currency_of_interest]="currency_of_interest_wrapper"
                        (_send_currency)="receive_currency($event)">
            </currencies>
        </div>
    `,
    styles: ['div { border: 5px dashed yellow; font-weight: normal; }', 'h2 { border: 5px dashed lightgreen; }']
})
export class Currencies_wrapper {
    private _currency_of_interest_wrapper: Currency = null;

    get currency_of_interest_wrapper(): Currency {
        return this._currency_of_interest_wrapper;
    }

    public read(): string {
        return this._currency_of_interest_wrapper !== null ? this._currency_of_interest_wrapper.common_symbol : "";
    }

// It must be 'public' to be accessed as the event handler of '_send_currency':
    public receive_currency(currency: Currency): void { // window.alert('receive: ' + JSON.stringify(currency));
        this._currency_of_interest_wrapper = currency;
    }
}
