// 'currencies.module.ts' file
import {NgModule} from '@angular/core'; // TypeScript decorator
import {CommonModule} from '@angular/common';
import {ReactiveFormsModule} from '@angular/forms';
import {HttpClientModule} from '@angular/common/http';
import {RouterModule} from '@angular/router'; // --routing

import {Currencies} from './currencies.component';
import {Currencies_controller} from './currencies-controller.component';
import {Currencies_information} from './currencies-information.component';
import {Currencies_menu} from './currencies-menu.component';
// import {Currencies_service} from './currencies-service';
import {Currencies_wrapper} from './currencies-wrapper.component';
import {Guess_material_icon} from './guess-material-icon.pipe';
import {My_asynchronous_validator} from './My_asynchronous_validator';

@NgModule({ // TypeScript decorator
// These components belong to *only one* module:
    // 'declarations' makes directives, components and pipes from the current module available to others in the module:
    declarations: [Currencies, Currencies_controller, Currencies_information, Currencies_menu, Currencies_wrapper, Guess_material_icon, My_asynchronous_validator],
    // 'imports': it makes the exported declarations of other modules available in the current module:
    imports: [CommonModule, HttpClientModule, ReactiveFormsModule, RouterModule.forRoot(Currencies_menu.Navigations)],
    exports: [
        // Currencies, // No needed export for use in 'Currencies_wrapper': both components belong to the same module...
        Currencies_menu, // App. level
        // Currencies_wrapper, // Because of routing, 'currencies-wrapper' tag is no longer used in 'app.component.html'...
        RouterModule // To let access to navigation at the app. level...
    ]
    // providers: [Currencies_service] // When you register a provider with a specific 'NgModule', the same instance of a service is available to all components in that 'NgModule'
})
export default class Currencies_module {
}
